/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>

/**
 * Initializes the action manager.
 */
void holdemActionInit();

/**
 * Adds an action to the action queue.
 * 
 * @param action Action to add to the queue.
 */
void holdemActionAdd(holdemaction_t action);

/**
 * Updates the action manager, which (in turn) updates all actions that are
 * currently running.
 */
void holdemActionUpdate();

/**
 * Cleans up the action manager and all actions.
 */
void holdemActionDispose();