/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "start.h"

holdemaction_t actionStart() {
  holdemaction_t action = {
    .init = &actionStartInit,
    .update = &actionStartUpdate,
    .dispose = &actionStartDispose
  };

  return action;
}

void actionStartInit(int32_t index, void *data) {
  // holdemactionstart_t *convData = data;

  // Prepare the match
  holdemMatchInit(&HOLDEM_GAME_STATE.match);
  holdemRoundInit(&HOLDEM_GAME_STATE.match);
  cardShuffle(HOLDEM_GAME_STATE.match.deck, HOLDEM_GAME_STATE.match.deckSize);
  holdemFlop(&HOLDEM_GAME_STATE.match);
}

void actionStartUpdate(int32_t index, void *data) {
}

void actionStartDispose(int32_t index, void *data) {

}