/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>
#include "../../../display/shader.h"
#include "../../../display/primitive.h"
#include "../../../display/primitives/quad.h"
#include "../../../display/spritebatch.h"
#include "../../../display/gui/font.h"
#include "../../../display/framebuffer.h"
#include "../../../display/camera.h"
#include "../../../display/primitives/cube.h"
#include "../../../display/tileset.h"
#include "../../../util/math.h"
#include "../model/pokertable.h"

/**
 * Prepare the Hold'em Game Renderer.
 */
void holdemRenderInit();

/**
 * Render the Texas Hold'em Game.
 */
void holdemRender();

void holdemLookSeat(camera_t *camera, uint8_t seat);
void holdemLookHand(camera_t *camera, uint8_t seat);

void holdemRenderPlayer(float x, float y, float z, float yaw);

void holdemRenderCard(card_t card,
  float x, float y, float z, float pitch, float yaw, float roll
);

void holdemRenderWorld();